/*
 * callbacks.h self explicative name :)
 */

#include "common.h"
#include "open.h"
#include "extract.h"
#include "delete.h"
#include "add.h"
#include "exit.h"
#include "new.h"
#include "callbacks.h"
#include "gconfig.h"


void
on_add_ok_button_clicked	       (GtkButton        *button,
                                        GtkFileSelection *file_sel)
{
	GList *addlist;
	gchar *adddir;
	gint num, i;
	
	if ((addlist = gz_add_selection_to_list (file_sel, &adddir)))
	{
		gtk_widget_destroy (add_win);
		gz_add(addlist, adddir);
	
		num = g_list_length (addlist);
		for (i = 0; i < num; i++) g_free (g_list_nth_data (addlist, i));
		g_list_free (addlist);
	}
	else gtk_widget_destroy (add_win);
}

void
on_add_path_entry_changed		(GtkEditable	*editable,
					gpointer	user_data)
{
	GtkWidget *tbutton;
	
	if (workdir) g_free (workdir);
	workdir = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_add_path_entry_changed:", workdir)
	if ((tbutton = lookup_widget (add_win, "thispath_radiobutton")) != NULL)
			gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (tbutton), TRUE);
	else ERROR (_("Internal Error"), _("Unable to find Button"))
}

void
on_add_radio_toggled			(GtkToggleButton *togglebutton,
					 gpointer	button)
{
	DEBUG ("on_add_radio_toggled:", "toggled");
	workdir_type = GPOINTER_TO_INT (button);
}

void
on_extract_path_entry_changed          (GtkEditable     *editable,
                                        gpointer         user_data)
{
	if (extract_dir) g_free (extract_dir);
	extract_dir = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_extract_path_entry_changed:", extract_dir)
}


void
on_overwrite_checkbutton_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	overwrite = !overwrite;
}


void
on_ok_extract_to_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_destroy (extract_win);
	gz_extract();
}


void
on_canc_extract_to_button_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_destroy (extract_win);
}


void
on_new_path_entry_changed              (GtkEditable     *editable,
                                        gpointer         user_data)
{
	if (new_filename) g_free (new_filename);
	new_filename = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_new_path_entry_changed:", filename)

}


void
on_new_at_combo_changed		       (GtkEditable	*editable,
					gpointer	 user_data)
{
	gchar *at_string;

	at_string = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_new_at_combo_changed:", at_string)
	if (g_strcasecmp (at_string, ".tar.gz") == 0) new_archive_type = FILE_TGZ;
	else if (g_strcasecmp (at_string, ".tar.bz2") == 0) new_archive_type = FILE_TBZ2;
	else if (g_strcasecmp (at_string, ".tar") == 0) new_archive_type = FILE_TAR;
	else if (g_strcasecmp (at_string, ".zip") == 0) new_archive_type = FILE_ZIP;
	else
	{
		ERROR (_("internal error:"), _("wrong archive type"));
		new_archive_type = FILE_UNKN;
	}
	g_free (at_string);
}

void
on_new_spinbutton_changed              (GtkEditable     *editable,
                                        gpointer         user_data)
{
	gchar *cl_string;

	cl_string = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_new_spinbutton_changed:", cl_string)
	switch (cl_string[0])
	{
	case '1':
		new_comp_lev = 1;
		break;
	case '2':
		new_comp_lev = 2;
		break;
	case '3':
		new_comp_lev = 3;
		break;
	case '4':
		new_comp_lev = 4;
		break;
	case '5':
		new_comp_lev = 5;
		break;
	case '6':
		new_comp_lev = 6;
		break;
	case '7':
		new_comp_lev = 7;
		break;
	case '8':
		new_comp_lev = 8;
		break;
	case '9':
		new_comp_lev = 9;
		break;
	default:
		ERROR (_("internal error:"), _("wrong compression level"));
	}
	g_free (cl_string);
}


void
on_ok_new_button_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	int retval;
	
	if ((retval = gz_new_file()) ==0)
	     gtk_widget_destroy (new_win);
}


void
on_canc_new_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_destroy (new_win);
}


void
on_new_fm_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	new_win = create_new_win ();
	gtk_widget_show (new_win);
}


void
on_open_fm_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gz_open_file_selection();
}


void
on_save_fm_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	DEBUG("on_save_fm_activate", "*\n");
}


void
on_save_as_fm_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gz_save_as_file_selection();
}


void
on_exit_fm_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	exit(0);
}


void
on_add_am_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if (fileopen)
	{
		add_win = create_add_win ();
		gtk_widget_show (add_win);
	}
	else ERROR (_("Add Files:"), _("No archives open"))
}


void
on_extract_am_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if (!fileopen)
	{
		ERROR ("extract...", _("no archives open"))
	}
	else
	{
		extract_win = create_extract_win ();
		gtk_widget_show (extract_win);
	}
}


void
on_delete_am_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gz_delete ();
}


void
on_select_all_am_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *main_clist;

	main_clist = gz_mainclist_get_widget ();
	gtk_clist_select_all (GTK_CLIST (main_clist));
}


void
on_test_archive_am_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	DEBUG("on_test_archive_am_activate", "*\n");
}


void
on_view_comment_am_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	DEBUG("on_view_comment_am_activate", "*\n");
}


void
on_preferences_sm_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	pref_win = create_pref_win ();
	gtk_widget_show (pref_win);
}


void
on_by_type_ssm_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	DEBUG("on_by_type_ssm_activate", "*\n");
}


void
on_by_name_ssm_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *main_clist = NULL;

	main_clist = gz_mainclist_get_widget ();
	on_clist_column_clicked (GTK_CLIST (main_clist), COL_NAME, NULL);
}


void
on_by_size_ssm_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *main_clist = NULL;

	main_clist = gz_mainclist_get_widget ();
	on_clist_column_clicked (GTK_CLIST (main_clist), COL_SIZE, NULL);
}


void
on_by_date_ssm_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *main_clist = NULL;

	main_clist = gz_mainclist_get_widget ();
	on_clist_column_clicked (GTK_CLIST (main_clist), COL_DATE, NULL);
}


void
on_by_time_ssm_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *main_clist = NULL;

	main_clist = gz_mainclist_get_widget ();
	on_clist_column_clicked (GTK_CLIST (main_clist), COL_TIME, NULL);
}


void
on_by_path_ssm_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *main_clist = NULL;

	main_clist = gz_mainclist_get_widget ();
	on_clist_column_clicked (GTK_CLIST (main_clist), COL_PATH, NULL);
}


void
on_save_settings_on_exit_sm_activate   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	saveonexit = !saveonexit;
}


void
on_save_settings_now_sm_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gz_config_write ();
}


void
on_set_default_settings_sm_activate    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gz_config_default ();
}


void
on_about_hm_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	about_gnozip = create_about_gnozip ();
	gtk_widget_show (about_gnozip);
}


void
on_open_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	gz_open_file_selection();
}


void
on_new_act_activate                    (GtkButton       *button,
                                        gpointer         user_data)
{
	new_win = create_new_win ();
	gtk_widget_show (new_win);
}


void
on_add_act_activate		       (GtkButton	*button,
					gpointer	 user_data)
{
	if (fileopen)
	{
		add_win = create_add_win ();
		gtk_widget_show (add_win);
	}
	else ERROR (_("Add Files:"), _("No archives open"))
}


void
on_extract_act_activate                (GtkButton       *button,
                                        gpointer         user_data)
{
	if (!fileopen)
	{
		ERROR ("extract...", _("no archives open"))
	}
	else
	{
		extract_win = create_extract_win ();
		gtk_widget_show (extract_win);
	}
}


void
on_del_button_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	gz_delete ();
}


gboolean
on_clist_column_clicked			(GtkCList       *clist,
                                        gint		 column,
                                        gpointer         user_data)
{
	
	if (column != clist->sort_column)
		gtk_clist_set_sort_column (clist, column);
	else
	{
		if (clist->sort_type == GTK_SORT_ASCENDING)
      			clist->sort_type = GTK_SORT_DESCENDING;
    		else
      			clist->sort_type = GTK_SORT_ASCENDING;
  	}
  	gtk_clist_sort (clist);

  return FALSE;
}


void
on_errdlog_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	DEBUG("on_errdlog_button_clicked", "***\n");
}


void
on_pref_view_icon_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	tempcfg.view.icon = !tempcfg.view.icon;
}

void
on_pref_view_name_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	tempcfg.view.name = !tempcfg.view.name;
}

void
on_pref_view_perms_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	tempcfg.view.perms = !tempcfg.view.perms;
}

void
on_pref_view_owner_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	tempcfg.view.owner = !tempcfg.view.owner;
}

void
on_pref_view_size_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	tempcfg.view.size = !tempcfg.view.size;
}

void
on_pref_view_date_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	tempcfg.view.date = !tempcfg.view.date;
}

void
on_pref_view_time_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	 tempcfg.view.time = !tempcfg.view.time;
}

void
on_pref_view_path_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	tempcfg.view.path = !tempcfg.view.path;
}

void
on_ddd_path_entry_changed              (GtkEditable     *editable,
                                        gpointer         user_data)
{
	g_free (tempcfg.dirs.defdir);
	tempcfg.dirs.defdir = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_ddd_path_entry_changed:", tempcfg.dirs.defdir)
}


void
on_scratch_path_entry_changed          (GtkEditable     *editable,
                                        gpointer         user_data)
{
	g_free (tempcfg.dirs.scratch);
	tempcfg.dirs.scratch = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_scratch_path_entry_changed:", tempcfg.dirs.scratch)
}


void
on_arj_path_entry_changed              (GtkEditable     *editable,
                                        gpointer         user_data)
{
	g_free (tempcfg.progs.arj);
	tempcfg.progs.arj = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_arj_path_entry_changed:", tempcfg.progs.arj)
}


void
on_lha_pathentry_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
	g_free (tempcfg.progs.lha);
	tempcfg.progs.lha = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_lha_path_entry_changed:", tempcfg.progs.lha)
}


void
on_bunzip2_path_entry_changed          (GtkEditable     *editable,
                                        gpointer         user_data)
{
	g_free (tempcfg.progs.bunzip2);
	tempcfg.progs.bunzip2 = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_bunzip2_path_entry_changed:", tempcfg.progs.bunzip2)
}


void
on_bzip2_path_entry_changed            (GtkEditable     *editable,
                                        gpointer         user_data)
{
	g_free (tempcfg.progs.bzip2);
	tempcfg.progs.bzip2 = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_bzip2_path_entry_changed:", tempcfg.progs.bzip2)
}


void
on_gunzip_path_entry_changed           (GtkEditable     *editable,
                                        gpointer         user_data)
{
	g_free (tempcfg.progs.gunzip);
	tempcfg.progs.gunzip = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_gunzip_path_entry_changed:", tempcfg.progs.gunzip)
}


void
on_gzip_path_entry_changed             (GtkEditable     *editable,
                                        gpointer         user_data)
{
	g_free (tempcfg.progs.gzip);
	tempcfg.progs.gzip = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_gzip_path_entry_changed:", tempcfg.progs.gzip)
}


void
on_tar_path_entry_changed              (GtkEditable     *editable,
                                        gpointer         user_data)
{
	g_free (tempcfg.progs.tar);
	tempcfg.progs.tar = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_tar_path_entry_changed:", tempcfg.progs.tar)
}


void
on_unzip_path_entry_changed            (GtkEditable     *editable,
                                        gpointer         user_data)
{
	g_free (tempcfg.progs.unzip);
	tempcfg.progs.unzip = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_unzip_path_entry_changed:", tempcfg.progs.unzip)
}


void
on_zip_path_entry_changed              (GtkEditable     *editable,
                                        gpointer         user_data)
{
	g_free (tempcfg.progs.zip);
	tempcfg.progs.zip = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_zip_path_entry_changed:", tempcfg.progs.zip)
}


void
on_viewer_path_entry_changed           (GtkEditable     *editable,
                                        gpointer         user_data)
{
	g_free (tempcfg.progs.viewer);
	tempcfg.progs.viewer = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_viewer_path_entry_changed:", tempcfg.progs.viewer)
}


void
on_rar_path_entry_changed              (GtkEditable     *editable,
                                        gpointer         user_data)
{
	g_free (tempcfg.progs.rar);
	tempcfg.progs.rar = g_strdup (gtk_editable_get_chars (editable, 0, -1));
	DEBUG ("on_rar_path_entry_changed:", tempcfg.progs.rar)
}


void
on_pref_ok_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	gz_config_cpy (&config, &tempcfg);
	gz_set_prefs ();
	gtk_widget_destroy (pref_win);
}


void
on_pref_apply_button_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
	gz_config_cpy (&config, &tempcfg);
	gz_set_prefs ();
}


void
on_pref_canc_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_destroy (pref_win);
}


void
on_quest_ok_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
	gint *retval = user_data;
	
	*retval = 0;
	gtk_widget_destroy (quest_dialog);
}


void
on_quest_canc_button_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
	gint *retval = user_data;
	
	*retval = 1;
	gtk_widget_destroy (quest_dialog);
}

gboolean
on_main_win_delete_event               (GtkWidget       *object,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gz_exit();
        return FALSE;
}

void
on_open_filesel_activate	       (GtkWidget	*object,
					GtkFileSelection *filesel)
{
	if (filename) g_free (filename);
	filename = g_strdup( gtk_file_selection_get_filename (filesel));

	gz_mainappbar_set_status (filename);

	gtk_widget_destroy( GTK_WIDGET (filesel));
	
	gz_open (filename);
}

void
on_save_as_filesel_activate		(GtkWidget	*object,
					 GtkFileSelection *filesel)
{
	gchar *command = NULL;
	
	if (savename) g_free (savename);
	savename = g_strdup( gtk_file_selection_get_filename (filesel));

	gz_mainappbar_set_status (savename);

	gtk_widget_destroy( GTK_WIDGET (filesel));

	if (filename)
	{
		command = g_strdup_printf ("cp -f \"%s\" \"%s\"", filename, savename);
		system (command);
	}
	else WARNING (_("Saving file as..."), _("No files open"));
}

gboolean
on_add_win_delete_event		       (GtkWidget       *object,
                                        GdkEvent        *event,
					gpointer         user_data)
{
	DEBUG ("add_win", "delete_event");
	return FALSE;
}

gboolean
on_extract_win_delete_event            (GtkWidget       *object,
                                        GdkEvent        *event,
					gpointer         user_data)
{
	DEBUG ("extract_win", "delete_event");
	return FALSE;
}

gboolean
on_new_win_delete_event                (GtkWidget       *object,
                                        GdkEvent        *event,
					gpointer         user_data)
{
	DEBUG ("new_win", "delete_event");
	return FALSE;
}


gboolean
on_about_gnozip_delete_event           (GtkWidget       *object,
                                        GdkEvent        *event,
					gpointer         user_data)
{
	DEBUG ("about_gnozip", "delete_event");
	return FALSE;
}


gboolean
on_error_dialog_delete_event           (GtkWidget       *object,
                                        GdkEvent        *event,
					gpointer         user_data)
{
	DEBUG ("error_dialog", "delete_event");
	return FALSE;
}


gboolean
on_pref_win_delete_event               (GtkWidget       *object,
                                        GdkEvent        *event,
					gpointer         user_data)
{
	DEBUG ("pref_win", "delete_event");
	return FALSE;
}


gboolean
on_quest_dialog_delete_event           (GtkWidget       *object,
                                        GdkEvent        *event,
					gpointer         user_data)
{
	gint *retval = user_data;
	
	*retval = 1;
	gtk_widget_destroy (quest_dialog);

	return FALSE;
}

