/*
 * delete.c
 * This file provides the delete functions required by gnozip
 */

#include "common.h"
#include "exit.h"
#include "tar.h"
#include "zip.h"
#include "gzip.h"
#include "bzip2.h"
#include "delete.h"

int
gz_delete ()
{
  GtkWidget *main_clist = NULL;
  gchar *name;
  gz_list_entry *data;
  gint filelenght = 0;
  GList *delete_file_list;
  
  main_clist = gz_mainclist_get_widget ();
  delete_file_list = gz_get_selected_filenames (GTK_CLIST(main_clist));
  
  switch (filetype)
  {
   case FILE_ZIP:
     ERROR ("gz_delete:", _("Function not yet implemented"))
     break;
   case FILE_GZIP:
     /* TODO: Should we delete the gz file? */
     ERROR ("gz_delete:", _("Function not yet implemented"))
     break;
   case FILE_BZIP2:
     /* TODO: Should we delete the gz file? */
     ERROR ("gz_delete:", _("Function not yet implemented"))
     break;
   case FILE_TGZ:
     gz_tar_delete (filename, delete_file_list, TAR_GZ);
     break;
   case FILE_TBZ2:
     gz_tar_delete (filename, delete_file_list, TAR_BZ2);
     break;
   case FILE_TAR:
     gz_tar_delete (filename, delete_file_list, TAR_TAR);
     break;
   case FILE_ARJ:
     ERROR ("gz_delete:", _("Function not yet implemented"))
     break;
   case FILE_LHA:
     ERROR ("gz_delete:", _("Function not yet implemented"))
     break;
   case FILE_RAR:
     ERROR ("gz_delete:", _("Function not yet implemented"))
     break;
   default:
     ERROR ("gz_delete:", _("no archives open"))
  }

  /*FIXME: free the Glist and it's contents */

  return 0;
}

