/*
 * dnd.c
 *
 * Provide Drag and Drop functions and callbacks to GnoZip.
 */

#include "common.h"
#include "open.h"
#include "dnd.h"

GtkTargetEntry dnd_mime[] = { {"text/uri-list", 0, TEXT_URI_LIST} };

void gz_dnd_data_receive (GtkWidget *widget, GdkDragContext *context,
			  gint x, gint y, GtkSelectionData *selection_data,
			  guint info, guint time, gpointer data)
{
  GList *textlist = NULL;

  if (info == TEXT_URI_LIST)
    textlist = gnome_uri_list_extract_filenames (selection_data->data);
    filename = (gchar *) g_malloc0 (strlen (textlist->data)+1);
    strcpy (filename, textlist->data);
    gnome_uri_list_free_strings (textlist);
    gz_open (filename);
}

void gz_dnd_init (void)
{
  GtkWidget *main_clist;

  main_clist = gz_mainclist_get_widget ();
  gtk_drag_dest_set (main_clist,
		     GTK_DEST_DEFAULT_ALL,
		     dnd_mime,
		     1,
		     GDK_ACTION_COPY);
  gtk_signal_connect (GTK_OBJECT (main_clist),
		      "drag_data_received",
		      GTK_SIGNAL_FUNC (gz_dnd_data_receive),
		      NULL);
}
