/*
 * main.c
 */

#include "common.h"
#include "dnd.h"
#include "gconfig.h"
#include "open.h"

struct poptOption cmdline_filename =
{
	"filename",
	'f',
	POPT_ARG_STRING,
	&arg_filename,
	0,
	"opens immediately the file specified",
	"FILENAME"
}; 

int
main (int argc, char *argv[])
{

/*  setlocale (LC_ALL, ""); */
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);


  gnomelib_register_popt_table (&cmdline_filename,
				"FILE Options");
  gnome_init ("gnozip", VERSION, argc, argv);

  gz_config_init ();

  main_win = create_main_win ();
  gtk_widget_show (main_win);
  
  gz_config_cpy (&tempcfg, &config);
  gz_set_prefs ();
  
  gz_dnd_init ();

  gz_icons_init ();
  
  if (arg_filename)
  {
	  filename = g_strdup (arg_filename);
	  gz_open (filename);
  }
  
  gtk_main ();
  return 0;
}

