/*
 * new.c
 * This file handles the creaion of new files
 */

#include "common.h"
#include "new.h"

int
gz_new_file (void)
{

	DEBUG ("on_ok_new_button_clicked", "new file");

	if (new_filename == NULL)
	{
		ERROR ("on_ok_new_button_clicked", _("File Name not specified!"))
		return 1;
	}
	
	if (filelist) gz_clear_filelist (&filelist, GTK_CLIST (gz_mainclist_get_widget ()));

	/* FIXME: Check if filename already has the extension
	 * Better have an option in config to avoid applying extension? */
	switch (new_archive_type)
	{
	case FILE_TGZ:
		filename = g_strconcat (new_filename, ".tar.gz", NULL);
		break;
	case FILE_TBZ2:
		filename = g_strconcat (new_filename, ".tar.bz2", NULL);
		break;
	case FILE_TAR:
		filename = g_strconcat (new_filename, ".tar", NULL);
		break;
	case FILE_ZIP:
		filename = g_strconcat (new_filename, ".zip", NULL);
		break;
	default:
		ERROR ("on_ok_new_button_clicked", _("Internal error!"))
		return -1;
	}
	g_free (new_filename);
	new_filename = NULL;
	filetype = new_archive_type;
	new_archive_type = FILE_TGZ;
	comp_lev = new_comp_lev;
	new_comp_lev = 6;

	gz_mainappbar_set_status (filename);
	
	fileopen = TRUE;
	
	return 0;
}
